#!/usr/bin/scriba -c
global const nl = "\n"
Const NumberOfCookies = 3
include cgi.bas
include "cc.ini"

option cgi$Method cgi::Get or cgi::Post

cgi::Header 200,"text/html"

'
' We are setting several cookies. The expiry time is ten seconds so you can test that
' the cookies are sent by the browser if you press some of the buttons fast enough,
' but it does not if you are slow. So you can test cookie expiry time.
'
for i=1 to NumberOfCookies 
  ' cookie(i) is i, no domain is defined, path is /, expires after 10 seconds, not secure
  cgi::SetCookie "cookie" & i,i,undef,"/",gmtime()+10,false
next i

cgi::FinishHeader


cgi::SymbolName "ServerSoftware",cgi::ServerSoftware()
cgi::SymbolName "ServerName",cgi::ServerName()
cgi::SymbolName "GatewayInterface",cgi::GatewayInterface()
cgi::SymbolName "ServerProtocol",cgi::ServerProtocol()
cgi::SymbolName "ServerPort",cgi::ServerPort()
cgi::SymbolName "RequestMethod",cgi::RequestMethod()
cgi::SymbolName "PathInfo",cgi::PathInfo()
cgi::SymbolName "PathTranslated",cgi::PathTranslated()
cgi::SymbolName "ScriptName",cgi::ScriptName()
cgi::SymbolName "QueryString",cgi::QueryString()
cgi::SymbolName "RemoteHost",cgi::RemoteHost()
cgi::SymbolName "RemoteAddress",cgi::RemoteAddress()
cgi::SymbolName "AuthType",cgi::AuthType()
cgi::SymbolName "RemoteUser",cgi::RemoteUser()
cgi::SymbolName "RemoteIdent",cgi::RemoteIdent()
cgi::SymbolName "ContentType",cgi::ContentType()
cgi::SymbolName "ContentLength",cgi::ContentLength()
cgi::SymbolName "UserAgent",cgi::UserAgent()
cgi::SymbolName "Cookiie",cgi::RawCookie()
cgi::SymbolName "curdir",curdir()

'-------------------------------------------------------
print cgi::ResolveHtml( """<HTML>
<HEAD>
<title>CGI parameter testing</title>
</HEAD>
<BODY><font face="VERDANA" size="2">
<H1>View CGI Parameters</H1>
This page shows the cgi parameters the way it was uploaded.
<!-- here is the result of the previous HTTP request -->
<FONT SIZE="3">
<PRE>
CGI system variables
-------------------
curdir == <!--curdir-->
ServerSoftware  = <!--ServerSoftware-->
ServerName      = <!--ServerName-->
GatewayInterface= <!--GatewayInterface-->
ServerProtocol  = <!--ServerProtocol-->
ServerPort      = <!--ServerPort-->
RequestMethod   = <!--RequestMethod-->
PathInfo        = <!--PathInfo-->
PathTranslated  = <!--PathTranslated-->
ScriptName      = <!--ScriptName-->
QueryString     = <!--QueryString-->
RemoteHost      = <!--RemoteHost-->
RemoteAddress   = <!--RemoteAddress-->
AuthType        = <!--AuthType-->
RemoteUser      = <!--RemoteUser-->
RemoteIdent     = <!--RemoteIdent-->
ContentType     = <!--ContentType-->
ContentLength   = <!--ContentLength-->
UserAgent       = <!--UserAgent-->
Cookie          = <!--RawCookie-->

""")

print "curdir()=",curdir(),"\n"

cgi::ResetSymbols

print "\nCookies:\n"
for i=1 to NumberOfCookies
  print "cookie" & i," ",cgi::Cookie("cookie" & i),"\n"
next i

print """Text field using Param("TEXT-FIELD") is """,cgi::Param("TEXT-FIELD"),nl,nl


if cgi::RequestMethod() = "GET" then
  print "GET text field using GetParam(\"TEXT-FIELD\") is ",cgi::GetParam("TEXT-FIELD"),nl
end if

if cgi::RequestMethod() = "POST" then
  print """POST text field using PostParam("TEXT-FIELD") is """,cgi::PostParam("TEXT-FIELD"),nl
  if cgi::ContentType() like "multipart*" then
    print "Original file name is ",cgi::FileName("FILE-UPLOAD-NAME"),nl
    if cgi::FileLength("FILE-UPLOAD-NAME") > 0 then
      print "File of length ",cgi::FileLength("FILE-UPLOAD-NAME")," bytes is saved\n"
      cgi::SaveFile "FILE-UPLOAD-NAME","d:\\MyProjects\\sb\\upload.txt"
    else
      print "There is no uploaded file."
    end if
  end if
end if

print "the command line is ",Command(),"is is\n<P>"

print """</PRE><TABLE><TR><TD BORDER=0 BGCOLOR="EEEEEE"><PRE>
A simple form to POST parameters:<BR>
<FORM METHOD="POST" ACTION="echo.bas">
<INPUT TYPE="TEXT" VALUE="DEFAULT TEXT" NAME="TEXT-FIELD">
<INPUT TYPE="SUBMIT" NAME="SUBMIT-BUTTON" VALUE="POST">
</FORM>
</PRE></TD><TD BORDER=1 width="20">&nbsp;</TD><TD BORDER=0 BGCOLOR="EEEEEE"><PRE>
A simple form to GET parameters:<BR>
<FORM METHOD="GET" ACTION="echo.bas">
<INPUT TYPE="TEXT" VALUE="DEFAULT TEXT" NAME="TEXT-FIELD">
<INPUT TYPE="SUBMIT" NAME="SUBMIT-BUTTON" VALUE=" GET ">
</FORM>
</PRE></TD></TR></TABLE><PRE>
<hr>
A simple form to POST parameters:<BR>
<FORM METHOD="POST" ACTION="echo.bas" ENCTYPE="multipart/form-data">
<INPUT TYPE="TEXT" VALUE="DEFAULT TEXT" NAME="TEXT-FIELD">
<INPUT TYPE="FILE" VALUE="FILE-UPLOAD-VALUE" NAME="FILE-UPLOAD-NAME">
<INPUT TYPE="SUBMIT" NAME="SUBMIT-BUTTON" VALUE="UPLOAD FILE">
</FORM>
<hr>
</BODY>
</HTML>
"""

